'==============================================================================
'  BTREEX.BAS
'  This example demonstrates the speed of dvBTree API
'  Programmed By: Michael Meeks 03-18-2000
'                 MWM Consulting
'
'  (UDT and speed method added by Patrice Terrier)
'
'  Compiler: PBDLL Version 6.0
'     Other: DDT
'
'  Sec - Number of Seconds it took to index
'  Rps - Number of Records per second during the index
'
'  dvBTree - Copyright (c) 1997, 1998, 1999, 2000 Patrice Terrier
'
'==============================================================================

#COMPILE EXE
#INCLUDE "DVBTREE.INC"

'-----------------------------------------------------------------
' Equates:  17
'-----------------------------------------------------------------
%WINAPI                                         = 1
%Black                                          = &H000000???
%BLACK_BRUSH                                    = 4
%WM_INITDIALOG                                  = &H110
%WM_CTLCOLORDLG                                 = &H136
%WS_OVERLAPPED                                  = &H0
%WS_VISIBLE                                     = &H10000000
%WS_CAPTION                                     = &H00C00000  ' WS_BORDER OR WS_DLGFRAME
%WS_SYSMENU                                     = &H00080000
%WS_THICKFRAME                                  = &H00040000
%WS_MINIMIZEBOX                                 = &H00020000
%WS_MAXIMIZEBOX                                 = &H00010000
%WS_OVERLAPPEDWINDOW                            = %WS_OVERLAPPED OR %WS_CAPTION OR %WS_SYSMENU OR %WS_THICKFRAME OR %WS_MINIMIZEBOX OR %WS_MAXIMIZEBOX
%IDOK                                           = 1
%IDCANCEL                                       = 2
%BS_DEFPUSHBUTTON                               = &H1&
%BS_DEFAULT                                     = %BS_DEFPUSHBUTTON

'-----------------------------------------------------------------
' TYPE and UNION structures:  1
'-----------------------------------------------------------------
TYPE LOGBRUSH
  lbStyle AS DWORD
  lbColor AS DWORD
  lbHatch AS LONG
END TYPE

'-----------------------------------------------------------------
' Declared Functions:  1
'-----------------------------------------------------------------
DECLARE FUNCTION CreateBrushIndirect LIB "GDI32.DLL" ALIAS "CreateBrushIndirect" (lpLogBrush AS LOGBRUSH) AS DWORD

TYPE SampleRecords           'random data in Sample.dat
    City AS STRING * 28
    STATE AS STRING * 2
    Zip AS STRING * 5
    AreaCode AS STRING * 3
    County AS STRING * 25
    Fips AS STRING * 5
    Perferred AS STRING * 1
    TimeZone AS STRING * 5
    Dst AS STRING * 1
    ZipCodeType AS STRING * 1
END TYPE
 
%IDOK               = 1      'DDT Controls
%IDCANCEL           = 2      'Used as an Exit Button
%IDLABELStime       = 3      'Label for sec/rps
%IDLABELRcount      = 4      'Label for Total Records
 
%BS_DEFAULT = 1
 
GLOBAL g_hDlg AS LONG
 
$AppTitle = "DVBTree Test Program"
 
CALLBACK FUNCTION OkButton()
 
  DIM rec AS SampleRecords, zName AS ASCIIZ * 260
 
' ** Let's say that we are starting the test!
  MSGBOX "Ready To Create Index file",64,"Index Testing"
  MOUSEPTR 11   'Let our users know we are busy
 
  zName = "BTREEX.NDX"
  Klen& = 5  ' <------- The key size - 5 for our zipcode
 
' ** Kill index if it already exist
  ErrCode& = dvKillFile(zName)
  
  CALL dvBtLockOff ' Turn lock mode Off when reindexing (New dvBTree function)
 
  GOTO MidMethod ' REM this if you want to test the UDT method

' ----------------------------------------------------------------------------------
' Using the UDT method
' ----------------------------------------------------------------------------------

' ** Open the data file (the one you would create)
  ErrCode& = dvFOpen("SAMPLE.DAT", 0, 1, hFile&)
' ** Build the buffer  
  SizeRec& = SIZEOF(rec):  Buf$ = SPACE$(SizeRec&)
' ** Get the total number of records in the file
  recs& = dvFlof(hFile&) \ SizeRec&   
 
' ** OPEN or CREATE the index
  ErrCode& = dvBtOpen(zName, Klen&, hBtFile&, BtErr&)

  StartTime! = TIMER    'get the tick count
 
' ** Insert array KeyName$() in the index
  IF ErrCode& = 0 THEN
     Ok& = -1
     FOR Record& = 1 TO recs&
 
       ' ** Get the record  
         Errcode& = dvFGetR(hFile&, (Buf$), Record&)
         IF ErrCode& = 0 THEN
            
          ' ** Fill up the UDT
            POKE$ VARPTR(Rec), PEEK$(STRPTR(Buf$), SizeRec&)
            InsertKey$ = Rec.Zip
            
          ' ** Build the ZIP code index
            ErrCode& = dvBtInsert(hBtFile&, (InsertKey$), Record&, BtErr&)
            IF BtErr& THEN
               Msg$ = "Error" + STR$(BtErr&) + " inserting key #" + STR$(Record&)
               MSGBOX Msg$,,"BTREEX"
               Ok& = 0
               EXIT FOR
            END IF
         ELSE
            Ok& = 0
            EXIT FOR
         END IF
     NEXT
  END IF
 
' ** Close index file
  CALL dvBtClose(hBtFile&)
' ** Close data file
  CALL dvFClose(hFile&)
  
  GOTO Report

MidMethod:
' ----------------------------------------------------------------------------------
' Using a large buffer and the MID$ method
' ----------------------------------------------------------------------------------

' ** Open the data file (the one you would create)
  ErrCode& = dvFOpen("SAMPLE.DAT", 0, 1, hFile&)
' ** Get the total number of records in the file
  recs& = dvFlof(hFile&) \ SIZEOF(rec)   
' ** Build the buffer  
  BigBuf$ = SPACE$(dvFlof(hFile&)): SizeRec& = SIZEOF(rec)
' ** Get the buffer  
  Errcode& = dvFGet(hFile&, (BigBuf$))
' ** Close the data file
  CALL dvFClose(hFile&)
  

' ** OPEN or CREATE the index
  ErrCode& = dvBtOpen(zName, Klen&, hBtFile&, BtErr&)

  StartTime! = TIMER    'get the tick count

' ** Insert array KeyName$() in the index
  IF ErrCode& = 0 THEN
     Ok& = -1
     FOR Record& = 1 TO recs&

         InsertKey$ = MID$(BigBuf$, Record& * SizeRec& - SizeRec& + 31, 5)
       
         ErrCode& = dvBtInsert(hBtFile&, (InsertKey$), Record&, BtErr&)
         IF BtErr& THEN
            Msg$ = "Error" + STR$(BtErr&) + " inserting key #" + STR$(Record&)
            MSGBOX Msg$,,"BTREEX"
            Ok& = 0
            EXIT FOR
         END IF
     NEXT
  END IF

  CALL dvBtClose(hBtFile&)  'close index file
  BigBuf$ = ""


Report: 
 
  CALL dvBtLockOn ' Restore lock mode to On (New dvBTree function)

' ** Let's show the results
  StatusTime! = TIMER
  TimeResults! = (StatusTime! - StartTime!)
  Msg$ = " Sec:" + STR$(TimeResults!) + " - Rps: " + STR$(INT((Record&) / (TimeResults!)))
 
  CONTROL SET TEXT g_hDlg, %IDLABELStime, Msg$
  CONTROL SET TEXT g_hDlg, %IDLABELRcount, " Total No. of Records:" & STR$(Record&-1)
 
  MOUSEPTR 0 ' We're done, so let's restore the mouse
 
' ** Let's show that we did it
  IF Ok& THEN
     MSGBOX LTRIM$(STR$(Record& - 1)) + " keys were succesfully inserted",,"XBTREE Result"
  END IF
 
END FUNCTION
 
'------------------------------------------------------------------------------
CALLBACK FUNCTION CancelButton()
 
  DIALOG END CBHNDL
 
END FUNCTION
'------------------------------------------------------------------------------
CALLBACK FUNCTION MainDlg_CallBack()
 
    STATIC hBrushBlack AS LONG
 
    SELECT CASE CBMSG
    CASE %WM_INITDIALOG
        LOCAL Lb AS LOGBRUSH
        Lb.lbStyle  = %BLACK_BRUSH
        Lb.lbColor  = %BLACK
        hBrushBlack = CreateBrushIndirect(Lb)
    CASE %WM_CTLCOLORDLG
        'paint the background of the Dailog
        FUNCTION = hBrushBlack
        EXIT FUNCTION
    END SELECT
END FUNCTION
'------------------------------------------------------------------------------
 
FUNCTION PBMAIN () AS LONG
 
    #REGISTER NONE
 
    LOCAL hDlg   AS LONG
    LOCAL result AS LONG
 
    ' ** Create a new dialog template
    DIALOG NEW 0, $AppTitle,,, 260, 36, _
                  %WS_SYSMENU OR %WS_CAPTION OR _
                  %WS_THICKFRAME OR %WS_OVERLAPPEDWINDOW OR _
                  %WS_VISIBLE , 0 TO hDlg
 
    g_hDlg = hDlg
 
    ' ** Add controls to it
    CONTROL ADD BUTTON, hDlg, %IDOK,"OK", 160, 10, 40, 14, %BS_DEFAULT CALL OkButton
    CONTROL ADD BUTTON, hDlg, %IDCANCEL, "Exit", 210, 10, 40, 14, 0 CALL CancelButton
    CONTROL ADD LABEL , hDlg, %IDLABELStime," Sec: ?    - Rps: ?" , 5,   5, 130, 10
    CONTROL ADD LABEL , hDlg, %IDLABELRcount," Total No. of Records:" , 5,   20, 130, 10
 
    ' ** Display the dialog
    DIALOG SHOW MODAL hDlg, CALL MainDlg_CallBack TO result
 
END FUNCTION
 
