' XBTREE.BAS.
'
' This example demonstrates the use of B-Tree API.
'
' Copyright (c) 1997, 1998, 1999, 2000 Patrice Terrier
'
#COMPILE EXE

#INCLUDE "DVBTREE.INC"

FUNCTION WinMain& (BYVAL CurInst&, BYVAL PrvInst&, CmdL AS ASCIIZ PTR, BYVAL CmdShow&) EXPORT

LOCAL zKey AS ASCIIZ * 256

BtreeName$ = "BTREE.NDX"
Klen& = 20  ' <------------------- The name you want for your index file

REDIM KeyName$(15)
KeyName$(1) = "GODOUNOV BORIS"   ' These key names should come from
KeyName$(2) = "ADENAUER KONRAD"  ' your main database
KeyName$(3) = "CALDWELL ERSKINE"
KeyName$(4) = "MURASAKI SHIKIBU"
KeyName$(5) = "NIETZSCHE FRIEDRICH"
KeyName$(6) = "VOLTAIRE FRANCOIS"
KeyName$(7) = "FERRARI ENZO"
KeyName$(8) = "LINCOLN ABRAHAM"
KeyName$(9) = "XENAKIS IANNIS"
KeyName$(10) = "BETTELHEIM BRUNO"
KeyName$(11) = "YELTSIN BORIS"
KeyName$(12) = "PASTEUR LOUIS"
KeyName$(13) = "OFFENBACH JACQUES"
KeyName$(14) = "REAGAN RONALD"
KeyName$(15) = "HUBBLE EDWIN"

BtreeExist& = dvExist((BtreeName$)) ' Test if index already exist

' OPEN or CREATE the index
ErrCode& = dvBtOpen((BtreeName$), Klen&, hBtFile&, BtErr&)

IF NOT BtreeExist& THEN ' Insert array KeyName$() in the index
   Ok& = -1
   FOR K& = 1 TO 15
       Record& = CLNG(K&): InsertKey$ = KeyName$(K&)
       ErrCode& = dvBtInsert(hBtFile&, (InsertKey$), Record&, BtErr&)
       IF BtErr& THEN
          Msg$ = "Error" + STR$(BtErr&) + " inserting key #" + STR$(K&)
          MsgBox Msg$,,"XBTREE"
          Ok& = 0
       END IF
   NEXT
   IF Ok& THEN
      MsgBox LTRIM$(STR$(K& - 1)) + " keys were successfully inserted",,"XBTREE"
   END IF
END IF

' Now test if a key already exit if no add it to the index
TestKey$ = "TERRIER PATRICE"
ErrCode& = dvBtSearch(hBtFile&, (TestKey$), Record&, BtErr&)
KeyPress& = 0
IF BtErr& = 0 THEN
   Msg$ = TestKey$ + " is already in the index."
   KeyPres& = -1
ELSEIF BtErr& = 1 THEN
   Record& = 16 ' <-------- Don't forget to pass the new record number
                '           it must be the one used in the main database !
   Errode& = dvBtInsert(hBtFile&, (TestKey$), Record&, BtErr&)
   IF BtErr& = 0 THEN
      Msg$ = TestKey$ + " was not in the index, it has been inserted."
   ELSE
      Msg$ = "Error" + STR$(BtErr&) + " inserting key " + TestKey$
   END IF
ELSE
   Msg$ = "Error" + STR$(BtErr&) + " inserting key " + TestKey$
END IF
MsgBox Msg$,,"XBTREE" ' Display status message to the user

' Now display all the keys from first to last.
Msg$ = "": Item& = 0
GetKey$ = "": Record& = 0
zKey = GetKey$
ErrCode& = dvBtFirst(hBtFile&, zKey, Record&, BtErr&)
GetKey$ = zKey
DO WHILE BtErr& = 0 AND ErrCode& = 0
   INCR Item&
   Msg$ = Msg$ + STR$(Record&) + CHR$(9) + GetKey$ + CHR$(13)
   ErrCode& = dvBtNext(hBtFile&, zKey, Record&, BtErr&)
   GetKey$ = zKey
LOOP
IF BtErr& < 2 THEN
   Msg$ = "     Watch the alphabetical order !" + CHR$(13,13) + _
           STR$(Item&) + " Keys has been found" + CHR$(13,13) + Msg$
ELSE
   Msg$ = "Error" + STR$(BtErr&) + " occurred reading the tree."
END IF
MsgBox Msg$,,"XBTREE" ' Display status message to the user

' Now display all the keys from Last to first.
Msg$ = "": Item& = 0
GetKey$ = "": Record& = 0
zKey = GetKey$
ErrCode& = dvBtLast(hBtFile&, zKey, Record&, BtErr&)
GetKey$ = zKey
DO WHILE BtErr& = 0 AND ErrCode& = 0
   INCR Item&
   Msg$ = Msg$ + STR$(Record&) + CHR$(9) + GetKey$ + CHR$(13)
   ErrCode& = dvBtPrev(hBtFile&, zKey, Record&, BtErr&)
   GetKey$ = zKey
LOOP
IF BtErr& < 2 THEN
   Msg$ = "     Watch the alphabetical order !" + CHR$(13,13) + _
           STR$(Item&) + " Keys has been found" + CHR$(13,13) + Msg$
ELSE
   Msg$ = "Error" + STR$(BtErr&) + " occurred reading the tree."
END IF
MsgBox Msg$,,"XBTREE" ' Display status message to the user

CALL dvBtClose(hBtFile&)

END FUNCTION