'+--------------------------------------------------------------------------+
'|                                                                          |
'|                                 DVBTREE                                  |
'|                                                                          |
'|                         ***  ASCIIZ VERSION ***                          |
'|                                                                          |
'|    Full 32-bit multi-user adaptation of the original Joe Vests B-Tree    |
'|                                                                          |
'|   Subroutines written for the PowerBASIC 32-bit compilers PB/CC, PBDLL.  |
'|                                                                          |
'+--------------------------------------------------------------------------+
'|                                                                          |
'|                         Author Patrice TERRIER                           |
'|            8 Domaine de Rochagnon. 38800 Champagnier  FRANCE             |
'|                                                                          |
'|                   copyright (c) 2002 Patrice TERRIER                     |
'|                                                                          |
'|                    E-mail: pterrier@zapsolution.com                      |
'|                                                                          |
'+--------------------------------------------------------------------------+
'|                           ZAP image solution                             |
'|                       http://www.zapsolution.com                         |
'+--------------------------------------------------------------------------+
'

DECLARE FUNCTION dvBtClose& LIB "DVBTREE.DLL" ALIAS "dvBtClose" (BYVAL hBtFile&)
DECLARE FUNCTION dvBtDelete& LIB "DVBTREE.DLL" ALIAS "dvBtDelete" (BYVAL hBtFile&, zRKey AS ASCIIZ, Record&, Bterr&)
DECLARE FUNCTION dvBtFirst& LIB "DVBTREE.DLL" ALIAS "dvBtFirst" (BYVAL hBtFile&, zRKey AS ASCIIZ, Record&, Bterr&)
DECLARE FUNCTION dvBtInsert& LIB "DVBTREE.DLL" ALIAS "dvBtInsert" (BYVAL hBtFile&, zRKey AS ASCIIZ, Record&, Bterr&)
DECLARE FUNCTION dvBtKeyNbr& LIB "DVBTREE.DLL" ALIAS "dvBtKeyNbr" (BYVAL hBtFile&)
DECLARE FUNCTION dvBtLast& LIB "DVBTREE.DLL" ALIAS "dvBtLast" (BYVAL hBtFile&, zRKey AS ASCIIZ, Record&, Bterr&)
     DECLARE SUB dvBtLockOff LIB "DVBTREE.DLL" ALIAS "dvBtLockOff" ()
     DECLARE SUB dvBtLockOn LIB "DVBTREE.DLL" ALIAS "dvBtLockOn" () 
DECLARE FUNCTION dvBtMatch& LIB "DVBTREE.DLL" ALIAS "dvBtMatch" (BYVAL hBtFile&, zRKey AS ASCIIZ, Record&, Bterr&)
DECLARE FUNCTION dvBtNext& LIB "DVBTREE.DLL" ALIAS "dvBtNext" (BYVAL hBtFile&, zRKey AS ASCIIZ, Record&, Bterr&)
DECLARE FUNCTION dvBtOpen& LIB "DVBTREE.DLL" ALIAS "dvBtOpen" (zFilName AS ASCIIZ, BYVAL Klen&, hBtFile&, Bterr&)
DECLARE FUNCTION dvBtPrev& LIB "DVBTREE.DLL" ALIAS "dvBtPrev" (BYVAL hBtFile&, zRKey AS ASCIIZ, Record&, Bterr&)
DECLARE FUNCTION dvBtSearch& LIB "DVBTREE.DLL" ALIAS "dvBtSearch" (BYVAL hBtFile&, zRKey AS ASCIIZ, Record&, Bterr&)
     DECLARE SUB dvDskPath LIB "DVBTREE.DLL" ALIAS "dvDskPath" (zDsk AS ASCIIZ, zPath AS ASCIIZ)
DECLARE FUNCTION dvExist& LIB "DVBTREE.DLL" ALIAS "dvExist" (zFileSpec AS ASCIIZ)
     DECLARE SUB dvFClose LIB "DVBTREE.DLL" ALIAS "dvFClose" (hFile&)
DECLARE FUNCTION dvFGet& LIB "DVBTREE.DLL" ALIAS "dvFGet" (BYVAL hFile&, zBuf AS ASCIIZ)
DECLARE FUNCTION dvFGetAt& LIB "DVBTREE.DLL" ALIAS "dvFGetAt" (BYVAL hFile&, BYVAL PosByte&, zBuf AS ASCIIZ)
DECLARE FUNCTION dvFGetR& LIB "DVBTREE.DLL" ALIAS "dvFGetR" (BYVAL hFile&, zBuf AS ASCIIZ, BYVAL Record&)
DECLARE FUNCTION dvFlof& LIB "DVBTREE.DLL" ALIAS "dvFlof" (BYVAL hFile&)
DECLARE FUNCTION dvFlush& LIB "DVBTREE.DLL" ALIAS "dvFlush" (BYVAL hFile&)
DECLARE FUNCTION dvFOpen& LIB "DVBTREE.DLL" ALIAS "dvFOpen" (zFilName AS ASCIIZ, BYVAL AccessMode&, BYVAL ShareMode&, hFile&)
DECLARE FUNCTION dvFPut& LIB "DVBTREE.DLL"  ALIAS "dvFPut" (BYVAL hFile&, zBuf AS ASCIIZ)
DECLARE FUNCTION dvFPutAt& LIB "DVBTREE.DLL" ALIAS "dvFPutAt" (BYVAL hFile&, BYVAL PosByte&, zBuf AS ASCIIZ)
DECLARE FUNCTION dvFPutR& LIB "DVBTREE.DLL" ALIAS "dvFPutR" (BYVAL hFile&, zBuf AS ASCIIZ, BYVAL Record&)
DECLARE FUNCTION dvFSeek& LIB "DVBTREE.DLL" ALIAS "dvFSeek" (hFile&, BYVAL PosByte&)
DECLARE FUNCTION dvKillFile& LIB "DVBTREE.DLL" ALIAS "dvKillFile" (zFilName AS ASCIIZ)
DECLARE FUNCTION dvFLock& LIB "DVBTREE.DLL" ALIAS "dvFLock" (BYVAL hFile&, BYVAL OffSet&, BYVAL Length&)
DECLARE FUNCTION dvSetEof& LIB "DVBTREE.DLL" ALIAS "dvSetEof" (BYVAL hFile&)
DECLARE FUNCTION dvSetEofAt& LIB "DVBTREE.DLL" ALIAS "dvSetEofAt" (BYVAL hFile&, BYVAL PosByte&)
DECLARE FUNCTION dvFSetSize& LIB "DVBTREE.DLL" ALIAS "dvFSetSize" (zFilName AS ASCIIZ, BYVAL PosByte&)
DECLARE FUNCTION dvUcase$ LIB "DVBTREE.DLL" ALIAS "dvUcase" (zStringToConvert AS ASCIIZ)
DECLARE FUNCTION dvFUnLock& LIB "DVBTREE.DLL" ALIAS "dvFUnLock" (BYVAL hFile&, BYVAL OffSet&, BYVAL Length&)
DECLARE FUNCTION dvFLoc& LIB "DVBTREE.DLL" ALIAS "dvFLoc" (hFile&)

DECLARE FUNCTION dvInstrB& LIB "DVBTREE.DLL" ALIAS "dvInstrB" (BYVAL FromPos&, zItem AS ASCIIZ, zSearch AS ASCIIZ)
     DECLARE SUB dvSplitN LIB "DVBTREE.DLL" ALIAS "dvSplitN" (zFullName AS ASCIIZ, zPathName AS ASCIIZ, zFilName AS ASCIIZ)

' Version 2.02 -----------------------------------------------------

DECLARE FUNCTION dvBtBefore& LIB "DVBTREE.DLL" ALIAS "dvBtBefore" (BYVAL hBtFile&, zRKey AS ASCIIZ, Record&, BtErr&)
DECLARE FUNCTION dvBtAfter& LIB "DVBTREE.DLL" ALIAS "dvBtAfter" (BYVAL hBtFile&, zRKey AS ASCIIZ, Record&, BtErr&) 

     DECLARE SUB dvDebug LIB "DVBTREE.DLL" ALIAS "dvDebug" (zMsg AS ASCIIZ)

'------------------------------------------------------------------------------
' Start of DV32ZLIB declare
'------------------------------------------------------------------------------
'DECLARE FUNCTION Cpress& LIB "DV32ZL20.DLL" ALIAS "compress" _
'                (Dest AS ANY, DestLen AS ANY, Src AS ANY, BYVAL SrcLen&)
'DECLARE FUNCTION Upress& LIB "DV32ZL20.DLL" ALIAS "uncompress" _
'                (Dest AS ANY, DestLen AS ANY, Src AS ANY, BYVAL SrcLen&)
'
'DECLARE FUNCTION FileCompress& LIB "DVBTREE.DLL" (SrcName$, DstName$)
'DECLARE FUNCTION FileUnCompress& LIB "DVBTREE.DLL" (SrcName$, DstName$)
'DECLARE FUNCTION Compress& LIB "DVBTREE.DLL" (TheString$)
'DECLARE FUNCTION Uncompress& LIB "DVBTREE.DLL" (TheString$, OriginalSize&)
'DECLARE FUNCTION Zignature$ LIB "DVBTREE.DLL" ()

'------------------------------------------------------------------------------
' End of DV32ZLIB declare
'------------------------------------------------------------------------------

TYPE BTRECORD
    HlfNode    AS INTEGER
    Klen       AS INTEGER
    DtaLen     AS INTEGER
    ItmLen     AS INTEGER
    IDCode     AS STRING * 2
    RootNode   AS LONG
    NxtNode    AS LONG
    LastDel    AS LONG
    NumAct     AS INTEGER
    NumKeys    AS LONG
    Filler     AS STRING * 994
    KeyLen     AS INTEGER
END TYPE
